unit Parser;

{$F+,N+,O+}

interface

function ParserAnalys(S: String; var R: Extended): Boolean;

implementation

uses
  MyProc;

const
  OnError: Boolean = false;
  FList: array [1..18] of String[4] =
 ('ABS', 'ATAN', 'COS', 'EXP',
  'LN', 'SIN', 'SQR', 'SQRT',
  'PI', 'TAN', 'ASIN', 'ACOS',
  'HSIN', 'HCOS', 'HTAN', 'AHS',
  'AHC', 'AHT');

procedure SendError;
begin
  Writeln('Error!');
  Halt(1);
end;

function MatematAnalys(S: String): Extended;
var
  I, J, N, K: Word;
  Sign: Char;
  R1, R2: Extended;
  TS: String;

procedure Routine1;
label
  L1, L2;
var
  PS: String;
begin
  Sign := S[N];
  I := N-1;
  while (I > 0) and (S[I] in ['0'..'9', '.']) do
  begin
    Dec(I);
    if (Copy(S, I-1, 2) = 'E+') or (Copy(S, I-1, 2) = 'E-') then
      Dec(I, 2);
    if (S[I] = '-') and (S[I-1] in ['+', '-', '*', '/']) then
      goto L1;
  end;
  Inc(I);
L1: Val(Copy(S, I, N-I), R1, J);
  if J <> 0 then goto L2;
  Val(Copy(S, N+1, Length(S)-N), R2, J);
  if J = 1 then goto L2;
  if J <> 0 then
    Val(Copy(S, N+1, J-1), R2, K);
  if J = 0 then PS := '' else PS := Copy(S, N+J, Length(S)-N-J+1);
  case Sign of
    '+': R1 := R1+R2;
    '-': R1 := R1-R2;
    '/': if R2 = 0 then goto L2 else R1 := R1/R2;
    '*': if Ln(Abs(R1)+1)+Ln(Abs(R2)+1) <= 11356 then R1 := R1*R2 else goto L2;
    '^': if R1 <= 0 then goto L2 else 
           if Ln(Abs(R1)+1)+Abs(R2) <= 11356 then
             R1 := Exp(Ln(Abs(R1)+1)+Abs(R2))
           else goto L2;
  end;
  Str(R1, TS);
  while TS[1] = ' ' do
    TS := Copy(TS, 2, Length(TS)-1);
  S := Copy(S, 1, I-1) + TS + PS;
  Exit;
L2: OnError := true;
end;

begin
  repeat
    I := Pos('*', S);
    J := Pos('/', S);
    if (I < J) and (I > 0) then N := I
    else if J > 0 then N := J else N := I;
    if N <> 0 then
      Routine1;
    if OnError then Exit;
  until N = 0;
  repeat
    I := 0;
    repeat
      Inc(I);
      if (Copy(S, I, 2) = 'E+') or
         (Copy(S, I, 2) = 'E-') then
        Inc(I, 2);
      if S[I] = '-' then
        if I = 1 then Inc(I) else
          if S[I-1] in ['+', '-', '*', '/'] then Inc(I);
    until (S[I] = '-') or (I > Length(S));
    if Length(S) < I then I := 0;
    J := 0;
    repeat
      Inc(J);
      if (Copy(S, J, 2) = 'E+') or
         (Copy(S, J, 2) = 'E-') then
        Inc(J, 2);
    until (S[J] = '+') or (I > Length(S));
    if Length(S) < J then J := 0;
    if (I < J) and (I > 0) then N := I
    else if J > 0 then N := J else N := I;
    if N <> 0 then
      Routine1;
    if OnError then Exit;
  until N = 0;
  Val(S, R1, I);
  MatematAnalys := R1;
end;

function ParenAnalys(S: String): Extended;
var
  I, J, N: Word;
  R: Extended;
  TS: String;
begin
  for I := 1 to Length(S) do
    if not (S[I] in ['0'..'9', 'E', '.', '(', ')', '+', '-', '*', '/']) then
    begin
      OnError := true;
      Exit;
    end;
  repeat
    if Pos('(', S) = 0 then
    begin
      if Pos(')', S) <> 0 then
        OnError := true
      else
        ParenAnalys := MatematAnalys(S);
      Exit;
    end
    else
    begin
      N := Pos('(', S);
      J := 0;
      I := N;
      repeat
        case S[I] of
          '(': Inc(J);
          ')': Dec(J);
        end;
        Inc(I);
      until (J = 0) or (I > Length(S));
      if J <> 0 then
      begin
        OnError := true;
        Exit;
      end;
      R := ParenAnalys(Copy(S, N+1, I-N-2));
      if OnError then Exit;
      Str(R, TS);
      while TS[1] = ' ' do
        TS := Copy(TS, 2, Length(TS)-1);
      Delete(S, N, I-N);
      Insert(TS, S, N);{ := Copy(S, 1, N-1) + TS + Copy(S, I, Length(S)-I+1);}
    end;
  until false;
end;

function FunctionAnalys(S: String): Extended;
var
  I, N, K, J, A: Word;
  TS: String;
  R: Extended;
begin
  S := UpReg(S);
  for A := 1 to 9 do
  begin
    K := Pos(FList[A], S);
    if K <> 0 then
    begin
      N := K + Length(FList[A]);
      J := 0;
      I := N;
      repeat
        case S[I] of
          '(': Inc(J);
          ')': Dec(J);
        end;
        Inc(I);
      until (J = 0) or (I > Length(S));
      if J <> 0 then
      begin
        OnError := true;
        Exit;
      end;
      R := FunctionAnalys(Copy(S, N+1, I-N-2));
      if OnError then Exit;
      case A of
        1: R := Abs(R);
        2: R := ArcTan(R);
        3: R := Cos(R);
        4: if Abs(R) <= 11356 then R := Exp(R) else OnError := true;
        5: if R > 0 then R := Ln(R) else OnError := true;
        6: R := Sin(R);
        7: if Abs(R) <= 1E2466 then R := Sqr(R) else OnError := true;
        8: if R >= 0 then R := Sqrt(R) else OnError := true;
        9: if R < 1E4932 then R := 3.14159265358979*R else OnError := true;
        10: R := Sin(R)/Cos(R);
        11: OnError := true;
        12: OnError := true;
        13: if Abs(R) <= 11356 then R := (Exp(R)-1/Exp(R))/2 else OnError := true;  
        14: if Abs(R) <= 11356 then R := (Exp(R)+1/Exp(R))/2 else OnError := true; 
        15: if Abs(R) <= 11356 then R := (Exp(R)-1/Exp(R))/(Exp(R)+1/Exp(R)) else OnError := true; 
        16: R := Ln(R + Sqrt(R*R + 1));
        17: if R >= 1 then R := Ln(R + Sqrt(R*R - 1)) else OnError := true;
        18: if (R >= -1) and (R <= 1) then R := Ln(Sqrt(R + 1)*Sqrt(1 - R)) else OnError := true;
      end;
      if OnError then Exit;
      Str(R, TS);
      while TS[1] = ' ' do
        TS := Copy(TS, 2, Length(TS)-1);
      Delete(S, K, I-K);
      Insert(TS, S, K);
    end;
  end;
  FunctionAnalys := ParenAnalys(S);
end;

function ParserAnalys(S: String; var R: Extended): Boolean;
begin
  R := FunctionAnalys(S);
  ParserAnalys := not OnError;
  OnError := false;
end;

end.
